#!/usr/bin/perl
use CGI qw(:standard);
use MLDBM::Sync;                    
use MLDBM qw(DB_File Storable);      
use MLDBM qw(MLDBM::Sync::SDBM_File); 
use Fcntl qw(:DEFAULT);            

my $file = "/tmp/auth";
my $header = "/var/www/htdocs/header.html";
my $footer = "/var/www/htdocs/footer.html";

if (param('auth') eq "YES") { auth_ip($ENV{REMOTE_ADDR}); }

print header . `cat $header`;
print "<a href=" . url() . "?auth=YES>CLICK HERE FOR 5 MINUTES OF FREE WEB ACCESS</a>\n";
print `cat $footer`;

sub auth_ip {
   my ($ip) = @_;
   my %cache;
   my $sync_dbm_obj = tie (%cache,'MLDBM::Sync',$file,O_CREAT|O_RDWR,0640);
   $sync_dbm_obj->Lock;
   my $time = time();
   $cache{$ip} = $time;
   $sync_dbm_obj->UnLock;
   untie (%cache);
}
